Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Program.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Program.cs	(revision 8816)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Program.cs	(revision 8817)
@@ -4,8 +4,25 @@
 using System.Text;
 using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+using HeuristicLab.Problems.TravelingSalesman;
+using System.Reflection;
+using System.IO;
+using Microsoft.Scripting.Hosting;
+using IronPython.Hosting;
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+using HeuristicLab.Persistence.Core;
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Services.Optimization.ControllerService.Tests {
   class Program {
     static void Main(string[] args) {
+      Console.WriteLine(AppDomain.CurrentDomain.BaseDirectory);    
+      //TestScenarioParser();
+      TestCodeDOM();
+      //TestPython();
+      //TestOtis();
+      //TestJobResults();
+    }
+
+    static void TestJobResults() {
       IScenarioManager manager = new HiveScenarioManager();
       Console.WriteLine("Press key to continue");
@@ -16,4 +33,192 @@
       }
     }
+
+    static void TestStorable() {
+      TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
+      GeneticAlgorithm algo = new GeneticAlgorithm();
+      algo.Problem = tsp;
+
+      
+    }
+
+    static void TestCodeDOM() {
+      ScenarioParser parser = new ScenarioParser();
+      var scen = parser.GetByName("Traveling Salesman Problem");
+      TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
+      GeneticAlgorithm algo = new GeneticAlgorithm();
+      algo.Problem = tsp;
+
+      // http://stackoverflow.com/questions/3188882/compile-and-run-dynamic-code-without-generating-exe
+      using (var csCodeProvider = new Microsoft.CSharp.CSharpCodeProvider()) {                
+
+        var cp = new System.CodeDom.Compiler.CompilerParameters() {
+            GenerateInMemory = true
+          };
+
+        var loadedAssemblies = AppDomain.CurrentDomain.GetAssemblies().ToList();
+        var loadedPaths = loadedAssemblies.Select(a => a.Location).ToArray();
+
+        var referencedPaths = Directory.GetFiles(AppDomain.CurrentDomain.BaseDirectory, "*.dll");
+        foreach (var loadedAssembly in referencedPaths) {
+          cp.ReferencedAssemblies.Add(loadedAssembly);          
+        }
+        cp.ReferencedAssemblies.Add("System.dll");
+
+        tsp.BestKnownQuality = HLMapper.ConvertToDoubleValue(scen.InputParameters.FindByName("BestKnownQuality"));
+        
+        var res = csCodeProvider.CompileAssemblyFromSource(
+         cp
+         ,
+          @"using System;
+            using System.Collections.Generic;
+            using System.Linq;
+            using System.Text;
+            using HeuristicLab.Data;
+            using HeuristicLab.Services.Optimization.ControllerService.Model; 
+            using HeuristicLab.Optimization;
+            using HeuristicLab.Services.Optimization.ControllerService;
+            using HeuristicLab.Algorithms.GeneticAlgorithm;
+            using HeuristicLab.Problems.TravelingSalesman;
+            public class TSPScenarioMapper : IScenarioMapper {
+              public void MapScenario(OptimizationScenario scenario, IAlgorithm algorithm) {
+                Console.WriteLine(""Mapping scenario!"");
+                var ga = algorithm as GeneticAlgorithm;
+                var problem = algorithm.Problem as TravelingSalesmanProblem;
+                
+                problem.BestKnownQuality = HLMapper.ConvertToDoubleValue(scenario.InputParameters.FindByName(""BestKnownQuality""));
+                problem.BestKnownSolution = HLMapper.ConvertToPermutation(scenario.InputParameters.FindByName(""BestKnownSolution""));
+                problem.Coordinates = HLMapper.ConvertToDoubleMatrix(scenario.InputParameters.FindByName(""Coordinates""));
+                var evalParam = HLMapper.GetStringValue(scenario.InputParameters.FindByName(""EvaluatorParameter""));
+                if (evalParam == ""HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator"") {
+                  problem.EvaluatorParameter.Value = new TSPRoundedEuclideanPathEvaluator();
+                }
+                else if (evalParam == ""HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator"") {
+                  problem.EvaluatorParameter.Value = new TSPGeoPathEvaluator();
+                }
+                else {
+                  problem.EvaluatorParameter.Value = new TSPEuclideanPathEvaluator();
+                }
+                problem.UseDistanceMatrix = HLMapper.ConvertToBoolValue(scenario.InputParameters.FindByName(""UseDistanceMatrix""));
+                Console.WriteLine(""Mapping algorithm..."");
+                ga.Mutator = HLMapper.FindInItemSet<HeuristicLab.Optimization.IManipulator>(ga.MutatorParameter.ValidValues, scenario.AlgorithmParameters.FindByName(""Mutator""));
+                ga.CrossoverParameter.Value = HLMapper.FindOperator<HeuristicLab.Optimization.ICrossover>(problem, scenario.AlgorithmParameters.FindByName(""CrossoverParameter""));
+                ga.Elites = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName(""Elites""));
+                ga.MaximumGenerations = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName(""MaximumGenerations""));
+                ga.MutationProbability = HLMapper.ConvertToPercentValue(scenario.AlgorithmParameters.FindByName(""MutationProbability""));                
+                ga.PopulationSize = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName(""PopulationSize""));
+                ga.Seed = HLMapper.ConvertToIntValue(scenario.AlgorithmParameters.FindByName(""Seed""));
+                ga.Selector = HLMapper.FindInItemSet<HeuristicLab.Optimization.ISelector>(ga.SelectorParameter.ValidValues, scenario.AlgorithmParameters.FindByName(""Selector""));
+                ga.SetSeedRandomly = HLMapper.ConvertToBoolValue(scenario.AlgorithmParameters.FindByName(""SetSeedRandomly""));
+              }
+            }"
+        );        
+
+        foreach (var error in res.Errors) {
+          Console.WriteLine(error);
+        }        
+        
+        var type = res.CompiledAssembly.GetType("TSPScenarioMapper");
+        var mapper = Activator.CreateInstance(type) as IScenarioMapper;
+        mapper.MapScenario(scen, algo);
+      }      
+    }
+
+    static void TestPython() {
+      ScenarioParser parser = new ScenarioParser();
+      var scen = parser.GetByName("Traveling Salesman Problem");
+      //TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
+      //GeneticAlgorithm algo = new GeneticAlgorithm();
+      //algo.Problem = tsp;
+      var rt = Python.CreateRuntime();
+      // workaround to load all referenced assemblies into the current AppDomain
+      var loadedAssemblies = AppDomain.CurrentDomain.GetAssemblies().ToList();
+      var loadedPaths = loadedAssemblies.Select(a => a.Location).ToArray();
+
+      var referencedPaths = Directory.GetFiles(AppDomain.CurrentDomain.BaseDirectory, "*.dll");
+      var toLoad = referencedPaths.Where(r => !loadedPaths.Contains(r, StringComparer.InvariantCultureIgnoreCase)).ToList();
+      toLoad.ForEach(path => loadedAssemblies.Add(AppDomain.CurrentDomain.Load(AssemblyName.GetAssemblyName(path))));
+
+      foreach (var assm in AppDomain.CurrentDomain.GetAssemblies()) {                
+        rt.LoadAssembly(assm);  
+      }
+      
+      /*var scope = rt.CreateScope();
+      scope.SetVariable("source", scen);
+      scope.SetVariable("target", tsp);*/
+      var engine = rt.GetEngine("py");
+      char op = ' ';
+      while (op != 'q') {
+        try {
+          TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
+          GeneticAlgorithm algo = new GeneticAlgorithm();
+          algo.Problem = tsp;
+          Console.WriteLine("\n\n===============================================================");
+          var script = engine.CreateScriptSourceFromFile(System.Configuration.ConfigurationManager.AppSettings["scenarioPath"] + @"\mapping.py");          
+          var scope = engine.CreateScope();
+          scope.SetVariable("source", scen);
+          scope.SetVariable("problem", tsp);
+          scope.SetVariable("algorithm", algo);          
+          script.Execute(scope);                    
+        }
+        catch (Exception e) {
+          Console.WriteLine(e);
+        }
+        Console.WriteLine("Hit 'q' to quit...");
+        op = Console.ReadKey().KeyChar;
+      }
+
+      /*dynamic script = rt.UseFile("C:/temp/scenarios/mapping.py");
+      script.SetVariable("source", scen);
+      script.SetVariable("target", tsp);
+      
+
+      script.mapObjects(scen, tsp);*/
+      
+    }
+
+    static void TestOtis() {
+      Console.WriteLine();
+      Otis.Configuration cfg = new Otis.Configuration();
+      Model.DecimalValue dv = new Model.DecimalValue();
+      dv.Value = 100;
+      Console.WriteLine(dv);
+      Console.WriteLine(typeof(HeuristicLab.Data.DoubleValue).AssemblyQualifiedName);
+      Console.WriteLine(typeof(System.Double).AssemblyQualifiedName);
+
+      // workaround to load all referenced assemblies into the current AppDomain
+      var loadedAssemblies = AppDomain.CurrentDomain.GetAssemblies().ToList();
+      var loadedPaths = loadedAssemblies.Select(a => a.Location).ToArray();
+
+      var referencedPaths = Directory.GetFiles(AppDomain.CurrentDomain.BaseDirectory, "*.dll");
+      var toLoad = referencedPaths.Where(r => !loadedPaths.Contains(r, StringComparer.InvariantCultureIgnoreCase)).ToList();
+      toLoad.ForEach(path => loadedAssemblies.Add(AppDomain.CurrentDomain.Load(AssemblyName.GetAssemblyName(path))));
+      
+      foreach (var assm in AppDomain.CurrentDomain.GetAssemblies()) {
+        //cfg.AddAssembly(assm);
+        cfg.AddAssemblyReference(assm);        
+      }
+      //cfg.AddAssemblyReference("HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec");
+      //cfg.AddAssemblyReference("HeuristicLab.Data-3.3.dll");
+      cfg.AddXmlFile(System.Configuration.ConfigurationManager.AppSettings["scenarioPath"] + @"\mapping.tsp.xml");
+
+      Otis.IAssembler<TravelingSalesmanProblem,Model.OptimizationScenario> asm = cfg.GetAssembler<TravelingSalesmanProblem,Model.OptimizationScenario>();
+      ScenarioParser parser = new ScenarioParser();
+      var scen = parser.GetByName("Traveling Salesman Problem");
+      TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
+      //tsp.BestKnownQuality = new Data.DoubleValue();
+      asm.Assemble(ref tsp, ref scen);
+      Console.WriteLine(tsp.BestKnownQuality);      
+    }
+
+    static void TestMapping() {
+    }
+
+    // template for mapping Model.OptimizationScenario & e.g. TSP
+    static void TestScenarioParser() {
+      ScenarioParser parser = new ScenarioParser();
+      var scen = parser.GetByName("Traveling Salesman Problem");
+      TravelingSalesmanProblem tsp = new TravelingSalesmanProblem();
+      // proceed with mapping between scen and tsp
+    }
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Properties/AssemblyInfo.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Properties/AssemblyInfo.cs	(revision 8817)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/Properties/AssemblyInfo.cs	(revision 8817)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Services.Optimization.ControllerService.Tests")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("FH-Hagenberg")]
+[assembly: AssemblyProduct("HeuristicLab.Services.Optimization.ControllerService.Tests")]
+[assembly: AssemblyCopyright("Copyright © FH-Hagenberg 2012")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("0e306445-a9b1-472f-91fb-e9772cd36173")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/mapping.py
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/mapping.py	(revision 8817)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/mapping.py	(revision 8817)
@@ -0,0 +1,88 @@
+from HeuristicLab.Data import DoubleValue, DoubleMatrix, BoolValue, IntValue, PercentValue
+from HeuristicLab.Encodings.PermutationEncoding import Permutation, PermutationTypes
+from HeuristicLab.Problems.TravelingSalesman import TSPRoundedEuclideanPathEvaluator, TSPGeoPathEvaluator, TSPEuclideanPathEvaluator
+from System import Array
+
+class HeuristicLabMapper:
+  def __init__(self):
+    self.__params = source.InputParameters
+
+  def UseParameters(self, params):
+    self.__params = params
+
+  def MapDoubleValue(self, name):
+    return DoubleValue(self.__params.FindByName(name).Value.Value)
+
+  def MapPermutation(self, name):
+    entries = Array.CreateInstance(int, self.__params.FindByName(name).Value.Value.Length)
+    i = 0
+    for value in self.__params.FindByName(name).Value.Value:
+      entries[i] = int(value)
+      i = i + 1
+    return Permutation(PermutationTypes.RelativeDirected, entries)  
+
+  def MapDoubleMatrix(self, name):
+    matrixEntries = self.__params.FindByName(name).Value.Value; 
+    result = Array.CreateInstance(float, matrixEntries.Length, matrixEntries[0].Length)
+    for i in range(matrixEntries.Length):    
+      for j in range(matrixEntries[i].Length):    
+        result[i, j] = matrixEntries[i][j]
+    return DoubleMatrix(result)  
+
+  def MapBoolValue(self, name):
+    return BoolValue(self.__params.FindByName(name).Value.Value)
+
+  def MapIntValue(self, name):
+    return IntValue(int(source.AlgorithmParameters.FindByName(name).Value.Value))
+
+  def MapPercentValue(self, name):
+    return PercentValue(self.__params.FindByName(name).Value.Value / 100)
+
+  def GetStringValue(self, name):
+    return self.__params.FindByName(name).Value.Value
+
+  def FindIn(self, name, lst):
+    param = self.__params.FindByName(name).Value.Value    
+    for operator in lst:  
+      if operator.Name == param:
+        return operator         
+    print "ERROR: Couldn't find " + name + " " + param
+    print "List: "
+    print lst   
+    return None
+
+  def FindOperator(self, name):
+    param = self.__params.FindByName(name).Value.Value    
+    for operator in problem.Operators:  
+      if operator.Name == param:
+        return operator      
+    return None
+
+
+mapper = HeuristicLabMapper()
+mapper.UseParameters(source.InputParameters)
+###### PROBLEM PARAMETERS ######
+problem.BestKnownQuality = mapper.MapDoubleValue("BestKnownQuality")
+problem.BestKnownSolution = mapper.MapPermutation("BestKnownSolution")
+problem.Coordinates = mapper.MapDoubleMatrix("Coordinates")
+evaluatorParameter = mapper.GetStringValue("EvaluatorParameter")
+if (evaluatorParameter == "HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator"):
+  problem.EvaluatorParameter.Value = TSPRoundedEuclideanPathEvaluator()
+elif (evaluatorParameter == "HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator"):
+  problem.EvaluatorParameter.Value = TSPGeoPathEvaluator()
+else:
+  problem.EvaluatorParameter.Value = TSPEuclideanPathEvaluator()
+problem.UseDistanceMatrix = mapper.MapBoolValue("UseDistanceMatrix")
+
+###### ALGORITHM PARAMETERS ######
+mapper.UseParameters(source.AlgorithmParameters)
+# CrossoverParameter - string
+algorithm.CrossoverParameter.Value = mapper.FindOperator("CrossoverParameter")
+algorithm.Elites = mapper.MapIntValue("Elites")
+algorithm.MaximumGenerations = mapper.MapIntValue("MaximumGenerations")
+algorithm.MutationProbability = mapper.MapPercentValue("MutationProbability")
+algorithm.Mutator = mapper.FindIn("Mutator", algorithm.MutatorParameter.ValidValues)
+algorithm.PopulationSize = mapper.MapIntValue("PopulationSize")
+algorithm.Seed = mapper.MapIntValue("Seed")
+algorithm.Selector = mapper.FindIn("Selector", algorithm.SelectorParameter.ValidValues)
+algorithm.SetSeedRandomly = mapper.MapBoolValue("SetSeedRandomly")
Index: /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/scenario.xsd
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/scenario.xsd	(revision 8817)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.ControllerService.Tests/mappings/scenario.xsd	(revision 8817)
@@ -0,0 +1,45 @@
+<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
+    xmlns="urn:scenario-schema"
+    elementFormDefault="qualified"
+    targetNamespace="urn:scenario-schema">
+
+ <xsd:element name="scenario" type="scenarioType"/>
+
+ <xsd:complexType name="scenarioType">
+  <xsd:sequence maxOccurs="1">   
+   <xsd:element name="name" type="xsd:string"/>
+   <xsd:element name="problemParameters" type="paramsType"/>
+   <xsd:element name="algorithmParameters" type="paramsType"/>
+  </xsd:sequence>
+  <xsd:attribute name="problemType" use="required"/>
+  <xsd:attribute name="algorithmType" use="required"/>
+  <xsd:attribute name="mapper" use="required"/>
+ </xsd:complexType>
+
+ <xsd:complexType name="paramsType">
+  <xsd:sequence>
+   <xsd:element name="param" type="parameterType" minOccurs="1" maxOccurs="unbounded"/>      
+  </xsd:sequence>  
+ </xsd:complexType>
+
+ <xsd:complexType name="parameterType">
+  <xsd:choice>
+   <xsd:element name="value" type="valueType" minOccurs="0" maxOccurs="unbounded"/> 
+   <xsd:element name="choice" type="choiceType" minOccurs="0" maxOccurs="unbounded"/>      
+  </xsd:choice>
+  <xsd:attribute name="type" type="xsd:string" use="required"/>
+  <xsd:attribute name="name" type="xsd:string" use="required"/>
+  <xsd:attribute name="value" type="xsd:string"/>
+ </xsd:complexType>
+ 
+ <xsd:complexType name="choiceType">    
+  <xsd:attribute name="name" type="xsd:string" use="required"/>
+  <xsd:attribute name="selected" type="xsd:string"/>
+ </xsd:complexType>
+ 
+ <xsd:complexType name="valueType">
+  <xsd:attribute name="v1" type="xsd:string"/>
+  <xsd:attribute name="v2" type="xsd:string"/>
+ </xsd:complexType>
+
+</xsd:schema>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.HiveController/HeuristicLab.Services.Optimization.HiveController.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.HiveController/HeuristicLab.Services.Optimization.HiveController.csproj	(revision 8817)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.HiveController/HeuristicLab.Services.Optimization.HiveController.csproj	(revision 8817)
@@ -0,0 +1,54 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{DDD9CC62-ED7D-48E0-834B-9876F130BB0F}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Services.Optimization.HiveController</RootNamespace>
+    <AssemblyName>HeuristicLab.Services.Optimization.HiveController</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Class1.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.HiveController/Properties/AssemblyInfo.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.HiveController/Properties/AssemblyInfo.cs	(revision 8817)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.HiveController/Properties/AssemblyInfo.cs	(revision 8817)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Services.Optimization.HiveController")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("FH-Hagenberg")]
+[assembly: AssemblyProduct("HeuristicLab.Services.Optimization.HiveController")]
+[assembly: AssemblyCopyright("Copyright © FH-Hagenberg 2012")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("6e1480c7-e1bf-4e1d-9409-54fee5ced46e")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 8816)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 8817)
@@ -25,4 +25,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <FilesToIncludeForPublish>AllFilesInProjectFolder</FilesToIncludeForPublish>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -136,4 +137,5 @@
     <Content Include="Global.asax" />
     <Content Include="ControllerService.svc" />
+    <Content Include="Mappings\tsp.xml" />
     <Content Include="Scripts\jquery-1.5.1-vsdoc.js" />
     <Content Include="Scripts\jquery-1.5.1.js" />
@@ -146,5 +148,7 @@
     <Content Include="Scripts\modernizr-1.7.js" />
     <Content Include="Scripts\modernizr-1.7.min.js" />
-    <Content Include="Web.config" />
+    <Content Include="Web.config">
+      <SubType>Designer</SubType>
+    </Content>
     <Content Include="Web.Debug.config">
       <DependentUpon>Web.config</DependentUpon>
@@ -247,4 +251,10 @@
   <ItemGroup>
     <Content Include="Views\Optimization\JobDetails.cshtml" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Mappings\mapping.py" />
+    <None Include="Mappings\scenario.xsd">
+      <SubType>Designer</SubType>
+    </None>
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/mapping.py
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/mapping.py	(revision 8817)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Mappings/mapping.py	(revision 8817)
@@ -0,0 +1,88 @@
+from HeuristicLab.Data import DoubleValue, DoubleMatrix, BoolValue, IntValue, PercentValue
+from HeuristicLab.Encodings.PermutationEncoding import Permutation, PermutationTypes
+from HeuristicLab.Problems.TravelingSalesman import TSPRoundedEuclideanPathEvaluator, TSPGeoPathEvaluator, TSPEuclideanPathEvaluator
+from System import Array
+
+class HeuristicLabMapper:
+  def __init__(self):
+    self.__params = source.InputParameters
+
+  def UseParameters(self, params):
+    self.__params = params
+
+  def MapDoubleValue(self, name):
+    return DoubleValue(self.__params.FindByName(name).Value.Value)
+
+  def MapPermutation(self, name):
+    entries = Array.CreateInstance(int, self.__params.FindByName(name).Value.Value.Length)
+    i = 0
+    for value in self.__params.FindByName(name).Value.Value:
+      entries[i] = int(value)
+      i = i + 1
+    return Permutation(PermutationTypes.RelativeDirected, entries)  
+
+  def MapDoubleMatrix(self, name):
+    matrixEntries = self.__params.FindByName(name).Value.Value; 
+    result = Array.CreateInstance(float, matrixEntries.Length, matrixEntries[0].Length)
+    for i in range(matrixEntries.Length):    
+      for j in range(matrixEntries[i].Length):    
+        result[i, j] = matrixEntries[i][j]
+    return DoubleMatrix(result)  
+
+  def MapBoolValue(self, name):
+    return BoolValue(self.__params.FindByName(name).Value.Value)
+
+  def MapIntValue(self, name):
+    return IntValue(int(source.AlgorithmParameters.FindByName(name).Value.Value))
+
+  def MapPercentValue(self, name):
+    return PercentValue(self.__params.FindByName(name).Value.Value / 100)
+
+  def GetStringValue(self, name):
+    return self.__params.FindByName(name).Value.Value
+
+  def FindIn(self, name, lst):
+    param = self.__params.FindByName(name).Value.Value    
+    for operator in lst:  
+      if operator.Name == param:
+        return operator         
+    print "ERROR: Couldn't find " + name + " " + param
+    print "List: "
+    print lst   
+    return None
+
+  def FindOperator(self, name):
+    param = self.__params.FindByName(name).Value.Value    
+    for operator in problem.Operators:  
+      if operator.Name == param:
+        return operator      
+    return None
+
+
+mapper = HeuristicLabMapper()
+mapper.UseParameters(source.InputParameters)
+###### PROBLEM PARAMETERS ######
+problem.BestKnownQuality = mapper.MapDoubleValue("BestKnownQuality")
+problem.BestKnownSolution = mapper.MapPermutation("BestKnownSolution")
+problem.Coordinates = mapper.MapDoubleMatrix("Coordinates")
+evaluatorParameter = mapper.GetStringValue("EvaluatorParameter")
+if (evaluatorParameter == "HeuristicLab.Problems.TravelingSalesman.TSPRoundedEuclideanPathEvaluator"):
+  problem.EvaluatorParameter.Value = TSPRoundedEuclideanPathEvaluator()
+elif (evaluatorParameter == "HeuristicLab.Problems.TravelingSalesman.TSPGeoPathEvaluator"):
+  problem.EvaluatorParameter.Value = TSPGeoPathEvaluator()
+else:
+  problem.EvaluatorParameter.Value = TSPEuclideanPathEvaluator()
+problem.UseDistanceMatrix = mapper.MapBoolValue("UseDistanceMatrix")
+
+###### ALGORITHM PARAMETERS ######
+mapper.UseParameters(source.AlgorithmParameters)
+# CrossoverParameter - string
+algorithm.CrossoverParameter.Value = mapper.FindOperator("CrossoverParameter")
+algorithm.Elites = mapper.MapIntValue("Elites")
+algorithm.MaximumGenerations = mapper.MapIntValue("MaximumGenerations")
+algorithm.MutationProbability = mapper.MapPercentValue("MutationProbability")
+algorithm.Mutator = mapper.FindIn("Mutator", algorithm.MutatorParameter.ValidValues)
+algorithm.PopulationSize = mapper.MapIntValue("PopulationSize")
+algorithm.Seed = mapper.MapIntValue("Seed")
+algorithm.Selector = mapper.FindIn("Selector", algorithm.SelectorParameter.ValidValues)
+algorithm.SetSeedRandomly = mapper.MapBoolValue("SetSeedRandomly")
